diff --git a/src/main/java/net/minecraft/client/player/controller/PlayerController.java b/src/main/java/net/minecraft/client/player/controller/PlayerController.java
index 1988619e3..13334491a 100644
--- a/src/main/java/net/minecraft/client/player/controller/PlayerController.java
+++ b/src/main/java/net/minecraft/client/player/controller/PlayerController.java
@@ -14,6 +14,8 @@ import net.minecraft.core.item.tag.ItemTags;
 import net.minecraft.core.util.helper.Side;
 import net.minecraft.core.world.World;
 
+import static net.minecraft.core.world.LevelListener.EVENT_BLOCK_BREAK;
+
 public abstract class PlayerController {
 	
 	protected float currentDamage;
@@ -31,7 +33,7 @@ public abstract class PlayerController {
 	
 	//Called when the mouse is clicked and about 5 times per second while the button is held down
 	//Repeat is false when the mouse was clicked this frame
-	public void startDestroyBlock(int x, int y, int z, Side side, boolean repeat) {
+	public void startDestroyBlock(int x, int y, int z, Side side, double xHit, double yHit, boolean repeat) {
 		if(!mc.thePlayer.getGamemode().doBlockBreakingAnim()) {
 			swingItem(true);
 			
@@ -41,7 +43,7 @@ public abstract class PlayerController {
 			}
 			
 			destroyBlock(x, y, z, side, mc.thePlayer);
-			sendStartDigPacket(x, y, z, side);
+			sendStartDigPacket(x, y, z, side, xHit, yHit);
 			return;
 		}
 
@@ -51,15 +53,15 @@ public abstract class PlayerController {
 			
 			if(mineStrength < 1.0f) {
 				if(!repeat) {
-					sendStartDigPacket(x, y, z, side);
-					hitBlock(x, y, z, side);
+					sendStartDigPacket(x, y, z, side, xHit, yHit);
+					hitBlock(x, y, z, side, xHit, yHit);
 				}
 			}
 		}
 	}
 	
 	//Called 20 times per second when the mouse button is held and blocks are targeted
-	public void continueDestroyBlock(int x, int y, int z, Side side) {
+	public void continueDestroyBlock(int x, int y, int z, Side side, double xHit, double yHit) {
 		if(!mc.thePlayer.getGamemode().doBlockBreakingAnim()) {
 			return;
 		}
@@ -82,7 +84,7 @@ public abstract class PlayerController {
 				setMineBlock(x, y, z);
 				destroyBlock(x, y, z, side, mc.thePlayer);
 				//Start Dig Packet acts as block destroy packet when instantmining
-				sendStartDigPacket(x, y, z, side);
+				sendStartDigPacket(x, y, z, side, xHit, yHit);
 				
 				currentDamage = 0.0f;
 				previousDamage = 0.0f;
@@ -92,7 +94,7 @@ public abstract class PlayerController {
 				//Regular Mining
 				
 				if(!isMiningBlock(x, y, z)) {
-					sendStartDigPacket(x, y, z, side);
+					sendStartDigPacket(x, y, z, side, xHit, yHit);
 					currentDamage = 0.0f;
 					previousDamage = 0.0f;
 					setMineBlock(x, y, z);
@@ -104,7 +106,7 @@ public abstract class PlayerController {
 				currentDamage += mineStrength;
 				if(currentDamage > 1.0f) {
 					destroyBlock(x, y, z, side, mc.thePlayer);
-					sendDestroyBlockPacket(x, y, z, side);
+					sendDestroyBlockPacket(x, y, z, side, xHit, yHit);
 					currentDamage = 0.0f;
 					previousDamage = 0.0f;
 					soundDelay = 0;
@@ -155,7 +157,7 @@ public abstract class PlayerController {
 			heldItem = heldItemStack.getItem();
 		}
 		
-		world.playSoundEffect(2001, x, y, z, block.id);
+		world.playSoundEffect(EVENT_BLOCK_BREAK, x, y, z, block.id);
 		int meta = world.getBlockMetadata(x, y, z);
 		boolean removed = world.setBlockWithNotify(x, y, z, 0);
 		if(removed) {
@@ -174,12 +176,12 @@ public abstract class PlayerController {
 		}
 	}
 	
-	protected void hitBlock(int x, int y, int z, Side side) {
+	protected void hitBlock(int x, int y, int z, Side side, double xHit, double yHit) {
 		mc.theWorld.onBlockHit(mc.thePlayer, x, y, z, side);
 		
 		Block block = Block.getBlock(mc.theWorld.getBlockId(x, y, z));
 		if(block != null) {
-			block.onBlockClicked(mc.theWorld, x, y, z, mc.thePlayer);
+			block.onBlockLeftClicked(mc.theWorld, x, y, z, mc.thePlayer, side, xHit, yHit);
 		}
 	}
 	
@@ -250,7 +252,7 @@ public abstract class PlayerController {
 		if (!entityplayer.getGamemode().canInteract()) return false;
 		int i1 = world.getBlockId(blockX, blockY, blockZ);
 		if (!entityplayer.isSneaking() || entityplayer.inventory.getCurrentItem() == null) {
-			if (i1 > 0 && Block.blocksList[i1].blockActivated(world, blockX, blockY, blockZ, entityplayer)) {
+			if (i1 > 0 && Block.blocksList[i1].onBlockRightClicked(world, blockX, blockY, blockZ, entityplayer, side, xPlaced, yPlaced)) {
 				return true;
 			}
 		}
@@ -293,9 +295,9 @@ public abstract class PlayerController {
 
 	protected void syncCurrentPlayItem() {}
 	
-	public void sendStartDigPacket(int x, int y, int z, Side side) {}
+	public void sendStartDigPacket(int x, int y, int z, Side side, double xHit, double yHit) {}
 	
-	public void sendDestroyBlockPacket(int x, int y, int z, Side side) {}
+	public void sendDestroyBlockPacket(int x, int y, int z, Side side, double xHit, double yHit) {}
 
 	public void initLevel(World world) {}
 
diff --git a/src/main/java/net/minecraft/client/player/controller/PlayerControllerMP.java b/src/main/java/net/minecraft/client/player/controller/PlayerControllerMP.java
index 3d6540857..6ce1a2fda 100644
--- a/src/main/java/net/minecraft/client/player/controller/PlayerControllerMP.java
+++ b/src/main/java/net/minecraft/client/player/controller/PlayerControllerMP.java
@@ -39,19 +39,19 @@ public class PlayerControllerMP extends PlayerController {
 	}
 	
 	@Override
-	protected void hitBlock(int x, int y, int z, Side side) {
-		super.hitBlock(x, y, z, side);
-		netHandler.addToSendQueue(new Packet14BlockDig(1, x, y, z, side));
+	protected void hitBlock(int x, int y, int z, Side side, double xHit, double yHit) {
+		super.hitBlock(x, y, z, side, xHit, yHit);
+		netHandler.addToSendQueue(new Packet14BlockDig(1, x, y, z, side, xHit, yHit));
 	}
 	
 	@Override
-	public void sendStartDigPacket(int x, int y, int z, Side side) {
-		netHandler.addToSendQueue(new Packet14BlockDig(0, x, y, z, side));
+	public void sendStartDigPacket(int x, int y, int z, Side side, double xHit, double yHit) {
+		netHandler.addToSendQueue(new Packet14BlockDig(0, x, y, z, side, xHit, yHit));
 	}
 	
 	@Override
-	public void sendDestroyBlockPacket(int x, int y, int z, Side side) {
-		netHandler.addToSendQueue(new Packet14BlockDig(2, x, y, z, side));
+	public void sendDestroyBlockPacket(int x, int y, int z, Side side, double xHit, double yHit) {
+		netHandler.addToSendQueue(new Packet14BlockDig(2, x, y, z, side, xHit, yHit));
 	}
 	
 	@Override
diff --git a/src/main/java/net/minecraft/client/render/RenderGlobal.java b/src/main/java/net/minecraft/client/render/RenderGlobal.java
index be081a4dd..a6214d30d 100644
--- a/src/main/java/net/minecraft/client/render/RenderGlobal.java
+++ b/src/main/java/net/minecraft/client/render/RenderGlobal.java
@@ -1629,89 +1629,80 @@ public class RenderGlobal
             GLAllocation.deleteDisplayList(glRenderListBase);
         }
     }
-
     @Override
     public void levelEvent(EntityPlayer player, int id, int x, int y, int z, int data)
     {
         Random random = worldObj.rand;
-        switch(id)
-        {
-        default:
-            break;
-
-        case 1001: // Dispenser empty click
-            worldObj.playSoundEffect(null, SoundCategory.WORLD_SOUNDS, x, y, z, "random.click", 1.0F, 1.2F);
-            break;
-
-        case 1000: // Dispenser fire item
-            worldObj.playSoundEffect(null, SoundCategory.WORLD_SOUNDS, x, y, z, "random.click", 1.0F, 1.0F);
-            break;
-
-        case 1002: // Dispenser fire projectile
-            worldObj.playSoundEffect(null, SoundCategory.WORLD_SOUNDS, x, y, z, "random.bow", 1.0F, 1.2F);
-            break;
-
-        case 2000: // Dispenser eject particles
-            int j1 = data % 3 - 1;
-            int k1 = (data / 3) % 3 - 1;
-            double d = (double)x + (double)j1 * 0.6D + 0.5D;
-            double d1 = (double)y + 0.5D;
-            double d2 = (double)z + (double)k1 * 0.6D + 0.5D;
-            for(int l1 = 0; l1 < 10; l1++)
-            {
-                double d3 = random.nextDouble() * 0.2D + 0.01D;
-                double d4 = d + (double)j1 * 0.01D + (random.nextDouble() - 0.5D) * (double)k1 * 0.5D;
-                double d5 = d1 + (random.nextDouble() - 0.5D) * 0.5D;
-                double d6 = d2 + (double)k1 * 0.01D + (random.nextDouble() - 0.5D) * (double)j1 * 0.5D;
-                double d7 = (double)j1 * d3 + random.nextGaussian() * 0.01D;
-                double d8 = -0.03D + random.nextGaussian() * 0.01D;
-                double d9 = (double)k1 * d3 + random.nextGaussian() * 0.01D;
-                addParticle("smoke", d4, d5, d6, d7, d8, d9, 0);
-            }
+        switch(id) {
+            default:
+                break;
 
-            break;
+            case EVENT_DISPENSER_EMPTY: // Dispenser empty click
+                worldObj.playSoundEffect(null, SoundCategory.WORLD_SOUNDS, x, y, z, "random.click", 1.0F, 1.2F);
+                break;
 
-        case 2001: // Block break effect
-            int i2 = data;
-            if(i2 > 0)
-            {
-                Block block = Block.blocksList[i2];
+            case EVENT_DISPENSER_ITEM: // Dispenser fire item
+                worldObj.playSoundEffect(null, SoundCategory.WORLD_SOUNDS, x, y, z, "random.click", 1.0F, 1.0F);
+                break;
 
-                worldObj.playBlockSoundEffect(null, (float)x + 0.5F, (float)y + 0.5F, (float)z + 0.5F, block, EnumBlockSoundEffectType.MINE);
-            }
-            mc.effectRenderer.addBlockDestroyEffects(x, y, z, data, worldObj.getBlockMetadata(x, y, z));
-            break;
+            case EVENT_DISPENSER_PROJECTILE: // Dispenser fire projectile
+                worldObj.playSoundEffect(null, SoundCategory.WORLD_SOUNDS, x, y, z, "random.bow", 1.0F, 1.2F);
+                break;
 
-        case 1003: // Door sound
-            if(java.lang.Math.random() < 0.5D)
-            {
-                worldObj.playSoundEffect(null, SoundCategory.WORLD_SOUNDS, (double)x + 0.5D, (double)y + 0.5D, (double)z + 0.5D, "random.door_open", 1.0F, worldObj.rand.nextFloat() * 0.1F + 0.9F);
-            } else
-            {
-                worldObj.playSoundEffect(null, SoundCategory.WORLD_SOUNDS, (double)x + 0.5D, (double)y + 0.5D, (double)z + 0.5D, "random.door_close", 1.0F, worldObj.rand.nextFloat() * 0.1F + 0.9F);
-            }
-            break;
+            case EVENT_DISPENSER_PARTICLES: // Dispenser eject particles
+                int j1 = data % 3 - 1;
+                int k1 = (data / 3) % 3 - 1;
+                double d = (double)x + (double)j1 * 0.6D + 0.5D;
+                double d1 = (double)y + 0.5D;
+                double d2 = (double)z + (double)k1 * 0.6D + 0.5D;
+                for(int l1 = 0; l1 < 10; l1++) {
+                    double d3 = random.nextDouble() * 0.2D + 0.01D;
+                    double d4 = d + (double)j1 * 0.01D + (random.nextDouble() - 0.5D) * (double)k1 * 0.5D;
+                    double d5 = d1 + (random.nextDouble() - 0.5D) * 0.5D;
+                    double d6 = d2 + (double)k1 * 0.01D + (random.nextDouble() - 0.5D) * (double)j1 * 0.5D;
+                    double d7 = (double)j1 * d3 + random.nextGaussian() * 0.01D;
+                    double d8 = -0.03D + random.nextGaussian() * 0.01D;
+                    double d9 = (double)k1 * d3 + random.nextGaussian() * 0.01D;
+                    addParticle("smoke", d4, d5, d6, d7, d8, d9, 0);
+                }
 
-        case 1004: // Fire extinguish sound
-            worldObj.playSoundEffect(null, SoundCategory.WORLD_SOUNDS, (float)x + 0.5F, (float)y + 0.5F, (float)z + 0.5F, "random.fizz", 0.5F, 2.6F + (random.nextFloat() - random.nextFloat()) * 0.8F);
-            break;
+                break;
 
-        case 1005: // Jukebox play/stop record
-            if(Item.itemsList[data] instanceof ItemRecord)
-            {
-                ItemRecord record = ((ItemRecord)Item.itemsList[data]);
-                worldObj.playRecord(record.recordName, record.recordAuthor, x, y, z);
-            } else
-            {
-                worldObj.playRecord(null, null, x, y, z);
-            }
-            break;
-        case 1006: // Piston extend
-            worldObj.playSoundEffect(null, SoundCategory.WORLD_SOUNDS, (double)x + 0.5F, (double)y + 0.5F, (double)z + 0.5F, "tile.piston.out", 0.5F, worldObj.rand.nextFloat() * 0.25F + 0.6F);
-            break;
-        case 1007: // Piston retract
-            worldObj.playSoundEffect(null, SoundCategory.WORLD_SOUNDS, (double)x + 0.5F, (double)y + 0.5F, (double)z + 0.5F, "tile.piston.in", 0.5F, worldObj.rand.nextFloat() * 0.25F + 0.6F);
-            break;
+            case EVENT_BLOCK_BREAK: // Block break effect
+                if(data > 0) {
+                    Block block = Block.blocksList[data];
+
+                    worldObj.playBlockSoundEffect(null, (float)x + 0.5F, (float)y + 0.5F, (float)z + 0.5F, block, EnumBlockSoundEffectType.MINE);
+                }
+                mc.effectRenderer.addBlockDestroyEffects(x, y, z, data, worldObj.getBlockMetadata(x, y, z));
+                break;
+
+            case EVENT_DOOR_SOUND: // Door sound
+                if(java.lang.Math.random() < 0.5D) {
+                    worldObj.playSoundEffect(null, SoundCategory.WORLD_SOUNDS, (double)x + 0.5D, (double)y + 0.5D, (double)z + 0.5D, "random.door_open", 1.0F, worldObj.rand.nextFloat() * 0.1F + 0.9F);
+                } else {
+                    worldObj.playSoundEffect(null, SoundCategory.WORLD_SOUNDS, (double)x + 0.5D, (double)y + 0.5D, (double)z + 0.5D, "random.door_close", 1.0F, worldObj.rand.nextFloat() * 0.1F + 0.9F);
+                }
+                break;
+
+            case EVENT_FIRE_EXTINGUISH: // Fire extinguish sound
+                worldObj.playSoundEffect(null, SoundCategory.WORLD_SOUNDS, (float)x + 0.5F, (float)y + 0.5F, (float)z + 0.5F, "random.fizz", 0.5F, 2.6F + (random.nextFloat() - random.nextFloat()) * 0.8F);
+                break;
+
+            case EVENT_JUKEBOX_TOGGLE: // Jukebox play/stop record
+                if(Item.itemsList[data] instanceof ItemRecord) {
+                    ItemRecord record = ((ItemRecord)Item.itemsList[data]);
+                    worldObj.playRecord(record.recordName, record.recordAuthor, x, y, z);
+                } else {
+                    worldObj.playRecord(null, null, x, y, z);
+                }
+                break;
+            case EVENT_PISTON_EXTEND: // Piston extend
+                worldObj.playSoundEffect(null, SoundCategory.WORLD_SOUNDS, (double)x + 0.5F, (double)y + 0.5F, (double)z + 0.5F, "tile.piston.out", 0.5F, worldObj.rand.nextFloat() * 0.25F + 0.6F);
+                break;
+            case EVENT_PISTON_RETRACT: // Piston retract
+                worldObj.playSoundEffect(null, SoundCategory.WORLD_SOUNDS, (double)x + 0.5F, (double)y + 0.5F, (double)z + 0.5F, "tile.piston.in", 0.5F, worldObj.rand.nextFloat() * 0.25F + 0.6F);
+                break;
         }
     }
     
diff --git a/src/main/java/net/minecraft/core/block/Block.java b/src/main/java/net/minecraft/core/block/Block.java
index 957b0eb7d..0535bb271 100644
--- a/src/main/java/net/minecraft/core/block/Block.java
+++ b/src/main/java/net/minecraft/core/block/Block.java
@@ -475,7 +475,7 @@ public class Block
     	return world.canPlaceInsideBlock(x, y, z);
     }
 
-    public boolean blockActivated(World world, int x, int y, int z, EntityPlayer player)
+    public boolean onBlockRightClicked(World world, int x, int y, int z, EntityPlayer player, Side side, double xHit, double yHit)
     {
         return false;
     }
@@ -484,7 +484,7 @@ public class Block
     {
     }
 
-    public void onBlockClicked(World world, int x, int y, int z, EntityPlayer player)
+    public void onBlockLeftClicked(World world, int x, int y, int z, EntityPlayer player, Side side, double xHit, double yHit)
     {
     }
 
diff --git a/src/main/java/net/minecraft/core/block/BlockBasket.java b/src/main/java/net/minecraft/core/block/BlockBasket.java
index 92a4b67f7..3ad1baa15 100644
--- a/src/main/java/net/minecraft/core/block/BlockBasket.java
+++ b/src/main/java/net/minecraft/core/block/BlockBasket.java
@@ -6,6 +6,7 @@ import net.minecraft.core.entity.player.EntityPlayer;
 import net.minecraft.core.enums.EnumDropCause;
 import net.minecraft.core.item.Item;
 import net.minecraft.core.item.ItemStack;
+import net.minecraft.core.util.helper.Side;
 import net.minecraft.core.world.WorldSource;
 import net.minecraft.core.world.World;
 
@@ -17,7 +18,7 @@ public class BlockBasket extends BlockTileEntity
     }
 
     @Override
-    public boolean blockActivated(final World world, final int x, final int y, final int z, final EntityPlayer entityplayer)
+    public boolean onBlockRightClicked(final World world, final int x, final int y, final int z, final EntityPlayer entityplayer, Side side, double xPlaced, double yPlaced)
     {
         final TileEntityBasket te = (TileEntityBasket) world.getBlockTileEntity(x, y, z);
 
diff --git a/src/main/java/net/minecraft/core/block/BlockBed.java b/src/main/java/net/minecraft/core/block/BlockBed.java
index 96c218a3a..cbe0c92b2 100644
--- a/src/main/java/net/minecraft/core/block/BlockBed.java
+++ b/src/main/java/net/minecraft/core/block/BlockBed.java
@@ -7,6 +7,7 @@ import net.minecraft.core.enums.EnumDropCause;
 import net.minecraft.core.enums.EnumSleepStatus;
 import net.minecraft.core.item.Item;
 import net.minecraft.core.item.ItemStack;
+import net.minecraft.core.util.helper.Side;
 import net.minecraft.core.world.World;
 import net.minecraft.core.world.WorldSource;
 import net.minecraft.core.world.chunk.ChunkCoordinates;
@@ -19,7 +20,7 @@ public class BlockBed extends Block {
 	}
 
 	@Override
-	public boolean blockActivated(World world, int x, int y, int z, EntityPlayer player) {
+	public boolean onBlockRightClicked(World world, int x, int y, int z, EntityPlayer player, Side side, double xPlaced, double yPlaced) {
 		if(world.isClientSide) {
 			return true;
 		}
diff --git a/src/main/java/net/minecraft/core/block/BlockBlastFurnace.java b/src/main/java/net/minecraft/core/block/BlockBlastFurnace.java
index 0e19b5db9..405ede2c7 100644
--- a/src/main/java/net/minecraft/core/block/BlockBlastFurnace.java
+++ b/src/main/java/net/minecraft/core/block/BlockBlastFurnace.java
@@ -6,6 +6,7 @@ import net.minecraft.core.block.entity.TileEntityBlastFurnace;
 import net.minecraft.core.entity.player.EntityPlayer;
 import net.minecraft.core.enums.EnumDropCause;
 import net.minecraft.core.item.ItemStack;
+import net.minecraft.core.util.helper.Side;
 import net.minecraft.core.world.World;
 
 import java.util.Random;
@@ -40,7 +41,7 @@ public class BlockBlastFurnace extends BlockFurnace
     }
 
     @Override
-    public boolean blockActivated(World world, int x, int y, int z, EntityPlayer player)
+    public boolean onBlockRightClicked(World world, int x, int y, int z, EntityPlayer player, Side side, double xPlaced, double yPlaced)
     {
         if(world.isClientSide)
         {
diff --git a/src/main/java/net/minecraft/core/block/BlockBrazier.java b/src/main/java/net/minecraft/core/block/BlockBrazier.java
index 33ceaedab..c73e3aa86 100644
--- a/src/main/java/net/minecraft/core/block/BlockBrazier.java
+++ b/src/main/java/net/minecraft/core/block/BlockBrazier.java
@@ -7,6 +7,7 @@ import net.minecraft.core.enums.EnumDropCause;
 import net.minecraft.core.item.ItemFirestriker;
 import net.minecraft.core.item.ItemStack;
 import net.minecraft.core.sound.SoundCategory;
+import net.minecraft.core.util.helper.Side;
 import net.minecraft.core.world.World;
 
 import java.util.Random;
@@ -40,7 +41,7 @@ public class BlockBrazier
     }
 
     @Override
-    public boolean blockActivated(World world, int x, int y, int z, EntityPlayer player) {
+    public boolean onBlockRightClicked(World world, int x, int y, int z, EntityPlayer player, Side side, double xPlaced, double yPlaced) {
         ItemStack heldItem = player.getHeldItem();
         if (heldItem != null && heldItem.getItem() instanceof ItemFirestriker && !burning) {
             if (world.getBlock(x + 1, y, z) instanceof BlockFluid ||
diff --git a/src/main/java/net/minecraft/core/block/BlockButton.java b/src/main/java/net/minecraft/core/block/BlockButton.java
index 9db91b6d5..4fc0ae902 100644
--- a/src/main/java/net/minecraft/core/block/BlockButton.java
+++ b/src/main/java/net/minecraft/core/block/BlockButton.java
@@ -233,15 +233,15 @@ public class BlockButton extends Block
     }
 
     @Override
-    public void onBlockClicked(World world, int x, int y, int z, EntityPlayer player)
+    public void onBlockLeftClicked(World world, int x, int y, int z, EntityPlayer player, Side side, double xHit, double yHit)
     {
     	if(!Item.hasTag(player.getCurrentEquippedItem(), ItemTags.PREVENT_LEFT_CLICK_INTERACTIONS)) {
-    		blockActivated(world, x, y, z, player);
+    		onBlockRightClicked(world, x, y, z, player, null, 0.0, 0.0);
     	}
     }
 
     @Override
-    public boolean blockActivated(World world, int x, int y, int z, EntityPlayer player)
+    public boolean onBlockRightClicked(World world, int x, int y, int z, EntityPlayer player, Side side, double xPlaced, double yPlaced)
     {
         int l = world.getBlockMetadata(x, y, z);
         int i1 = l & 7;
diff --git a/src/main/java/net/minecraft/core/block/BlockChest.java b/src/main/java/net/minecraft/core/block/BlockChest.java
index 0b4afd914..75f45cbc8 100644
--- a/src/main/java/net/minecraft/core/block/BlockChest.java
+++ b/src/main/java/net/minecraft/core/block/BlockChest.java
@@ -245,7 +245,7 @@ public class BlockChest extends BlockTileEntity {
 	}
 	
 	@Override
-	public boolean blockActivated(World world, int x, int y, int z, EntityPlayer player) {
+	public boolean onBlockRightClicked(World world, int x, int y, int z, EntityPlayer player, Side side, double xPlaced, double yPlaced) {
 		if(world.isClientSide) return true;
 		
 		checkIfOtherHalfExists(world, x, y, z);
diff --git a/src/main/java/net/minecraft/core/block/BlockChestLegacy.java b/src/main/java/net/minecraft/core/block/BlockChestLegacy.java
index f647566d7..8b16e2890 100644
--- a/src/main/java/net/minecraft/core/block/BlockChestLegacy.java
+++ b/src/main/java/net/minecraft/core/block/BlockChestLegacy.java
@@ -9,6 +9,7 @@ import net.minecraft.core.entity.player.EntityPlayer;
 import net.minecraft.core.enums.EnumDropCause;
 import net.minecraft.core.item.ItemStack;
 import net.minecraft.core.util.helper.Direction;
+import net.minecraft.core.util.helper.Side;
 import net.minecraft.core.world.World;
 
 @Deprecated
@@ -47,14 +48,14 @@ public class BlockChestLegacy extends BlockTileEntity {
 	}
 	
 	@Override
-	public boolean blockActivated(World world, int x, int y, int z, EntityPlayer player) {
+	public boolean onBlockRightClicked(World world, int x, int y, int z, EntityPlayer player, Side side, double xPlaced, double yPlaced) {
 		if(world.isClientSide) {
 			return true;
 		}
 		if(isLegacyChest(world, x, y, z)) {
 			updateLegacyChest(world, x, y, z);
 		}
-		return world.getBlock(x, y, z).blockActivated(world, x, y, z, player);
+		return world.getBlock(x, y, z).onBlockRightClicked(world, x, y, z, player, side, xPlaced, yPlaced);
 	}
 	
 	private void updateLegacyChest(World world, int x, int y, int z) {
diff --git a/src/main/java/net/minecraft/core/block/BlockDispenser.java b/src/main/java/net/minecraft/core/block/BlockDispenser.java
index 7eb395c69..b41656665 100644
--- a/src/main/java/net/minecraft/core/block/BlockDispenser.java
+++ b/src/main/java/net/minecraft/core/block/BlockDispenser.java
@@ -8,6 +8,7 @@ import net.minecraft.core.entity.projectile.*;
 import net.minecraft.core.item.IDispensable;
 import net.minecraft.core.item.Item;
 import net.minecraft.core.item.ItemStack;
+import net.minecraft.core.util.helper.Side;
 import net.minecraft.core.world.World;
 import net.minecraft.core.block.entity.TileEntity;
 import net.minecraft.core.block.entity.TileEntityDispenser;
@@ -74,7 +75,7 @@ public class BlockDispenser extends BlockTileEntityRotatable
 
 
     @Override
-    public boolean blockActivated(World world, int x, int y, int z, EntityPlayer player)
+    public boolean onBlockRightClicked(World world, int x, int y, int z, EntityPlayer player, Side side, double xPlaced, double yPlaced)
     {
         if(world.isClientSide)
         {
diff --git a/src/main/java/net/minecraft/core/block/BlockDoor.java b/src/main/java/net/minecraft/core/block/BlockDoor.java
index f2240c32c..cbfa6e537 100644
--- a/src/main/java/net/minecraft/core/block/BlockDoor.java
+++ b/src/main/java/net/minecraft/core/block/BlockDoor.java
@@ -10,6 +10,7 @@ import net.minecraft.core.enums.EnumDropCause;
 import net.minecraft.core.item.Item;
 import net.minecraft.core.item.ItemStack;
 import net.minecraft.core.item.tag.ItemTags;
+import net.minecraft.core.util.helper.Side;
 import net.minecraft.core.util.phys.AABB;
 import net.minecraft.core.util.phys.Vec3d;
 import net.minecraft.core.world.World;
@@ -106,14 +107,14 @@ public class BlockDoor extends Block
     }
     
     @Override
-	public void onBlockClicked(World world, int x, int y, int z, EntityPlayer player) {
+	public void onBlockLeftClicked(World world, int x, int y, int z, EntityPlayer player, Side side, double xHit, double yHit) {
     	if(!Item.hasTag(player.getCurrentEquippedItem(), ItemTags.PREVENT_LEFT_CLICK_INTERACTIONS)) {
-    		blockActivated(world, x, y, z, player);
+    		onBlockRightClicked(world, x, y, z, player, side, xHit, yHit);
     	}
     }
 
     @Override
-    public boolean blockActivated(World world, int x, int y, int z, EntityPlayer player)
+    public boolean onBlockRightClicked(World world, int x, int y, int z, EntityPlayer player, Side side, double xPlaced, double yPlaced)
     {
         if(blockMaterial == Material.metal)
         {
@@ -124,7 +125,7 @@ public class BlockDoor extends Block
         {
             if(Block.blocksList[world.getBlockId(x, y - 1, z)] instanceof BlockDoor)
             {
-            	Block.blocksList[world.getBlockId(x, y - 1, z)].blockActivated(world, x, y - 1, z, player);
+            	Block.blocksList[world.getBlockId(x, y - 1, z)].onBlockRightClicked(world, x, y - 1, z, player, side, xPlaced, yPlaced);
             }
             return true;
         }
diff --git a/src/main/java/net/minecraft/core/block/BlockEdible.java b/src/main/java/net/minecraft/core/block/BlockEdible.java
index dc0930049..76e6a1230 100644
--- a/src/main/java/net/minecraft/core/block/BlockEdible.java
+++ b/src/main/java/net/minecraft/core/block/BlockEdible.java
@@ -6,6 +6,7 @@ import net.minecraft.core.entity.player.EntityPlayer;
 import net.minecraft.core.enums.EnumDropCause;
 import net.minecraft.core.item.Item;
 import net.minecraft.core.item.ItemStack;
+import net.minecraft.core.util.helper.Side;
 import net.minecraft.core.world.World;
 import org.jetbrains.annotations.NotNull;
 
@@ -72,7 +73,7 @@ public abstract class BlockEdible extends Block {
     }
 
     @Override
-    public boolean blockActivated(World world, int x, int y, int z, EntityPlayer player)
+    public boolean onBlockRightClicked(World world, int x, int y, int z, EntityPlayer player, Side side, double xPlaced, double yPlaced)
     {
         eatSlice(world, x, y, z, player);
         return true;
diff --git a/src/main/java/net/minecraft/core/block/BlockFenceGate.java b/src/main/java/net/minecraft/core/block/BlockFenceGate.java
index d66cf1349..295482077 100644
--- a/src/main/java/net/minecraft/core/block/BlockFenceGate.java
+++ b/src/main/java/net/minecraft/core/block/BlockFenceGate.java
@@ -90,14 +90,14 @@ public class BlockFenceGate extends Block
     }
     
     @Override
-	public void onBlockClicked(World world, int x, int y, int z, EntityPlayer player) {
+	public void onBlockLeftClicked(World world, int x, int y, int z, EntityPlayer player, Side side, double xHit, double yHit) {
     	if(!Item.hasTag(player.getCurrentEquippedItem(), ItemTags.PREVENT_LEFT_CLICK_INTERACTIONS)) {
-    		blockActivated(world, x, y, z, player);
+    		onBlockRightClicked(world, x, y, z, player, null, 0.0, 0.0);
     	}
     }
     
     @Override
-    public boolean blockActivated(World world, int x, int y, int z, EntityPlayer player)
+    public boolean onBlockRightClicked(World world, int x, int y, int z, EntityPlayer player, Side side, double xPlaced, double yPlaced)
     {
         int l = world.getBlockMetadata(x, y, z);
         if(func_35291_d(l))
diff --git a/src/main/java/net/minecraft/core/block/BlockFlag.java b/src/main/java/net/minecraft/core/block/BlockFlag.java
index bc752bd81..fcbac8b3c 100644
--- a/src/main/java/net/minecraft/core/block/BlockFlag.java
+++ b/src/main/java/net/minecraft/core/block/BlockFlag.java
@@ -8,6 +8,8 @@ import net.minecraft.core.enums.EnumDropCause;
 import net.minecraft.core.item.Item;
 import net.minecraft.core.item.ItemStack;
 import com.mojang.nbt.CompoundTag;
+
+import net.minecraft.core.util.helper.Side;
 import net.minecraft.core.util.phys.AABB;
 import net.minecraft.core.world.World;
 import net.minecraft.core.world.WorldSource;
@@ -52,7 +54,7 @@ public class BlockFlag extends BlockTileEntity{
     }
 
 	@Override
-	public boolean blockActivated(World world, int x, int y, int z, EntityPlayer player) {
+	public boolean onBlockRightClicked(World world, int x, int y, int z, EntityPlayer player, Side side, double xPlaced, double yPlaced) {
 		if (!world.isClientSide) {
 			TileEntityFlag flag = (TileEntityFlag) world.getBlockTileEntity(x, y, z);
 			if (flag.owner != null && !flag.owner.isEmpty() && !player.username.equals(flag.owner)) {
diff --git a/src/main/java/net/minecraft/core/block/BlockFurnace.java b/src/main/java/net/minecraft/core/block/BlockFurnace.java
index 1f14dd775..3c150634e 100644
--- a/src/main/java/net/minecraft/core/block/BlockFurnace.java
+++ b/src/main/java/net/minecraft/core/block/BlockFurnace.java
@@ -8,6 +8,7 @@ import net.minecraft.core.entity.EntityItem;
 import net.minecraft.core.entity.player.EntityPlayer;
 import net.minecraft.core.enums.EnumDropCause;
 import net.minecraft.core.item.ItemStack;
+import net.minecraft.core.util.helper.Side;
 import net.minecraft.core.world.World;
 
 import java.util.Random;
@@ -86,7 +87,7 @@ public class BlockFurnace extends BlockTileEntityRotatable
     }
 
     @Override
-    public boolean blockActivated(World world, int x, int y, int z, EntityPlayer player)
+    public boolean onBlockRightClicked(World world, int x, int y, int z, EntityPlayer player, Side side, double xPlaced, double yPlaced)
     {
         if (!world.isClientSide) {
             TileEntityFurnace tileentityfurnace = (TileEntityFurnace) world.getBlockTileEntity(x, y, z);
diff --git a/src/main/java/net/minecraft/core/block/BlockJar.java b/src/main/java/net/minecraft/core/block/BlockJar.java
index f2dcf713c..09b8681c1 100644
--- a/src/main/java/net/minecraft/core/block/BlockJar.java
+++ b/src/main/java/net/minecraft/core/block/BlockJar.java
@@ -9,6 +9,7 @@ import net.minecraft.core.enums.EnumDropCause;
 import net.minecraft.core.item.Item;
 import net.minecraft.core.item.ItemStack;
 import net.minecraft.core.item.block.ItemBlock;
+import net.minecraft.core.util.helper.Side;
 import net.minecraft.core.util.phys.AABB;
 import net.minecraft.core.world.World;
 import net.minecraft.core.world.WorldSource;
@@ -70,7 +71,7 @@ public class BlockJar extends BlockTileEntity{
         return false;
     }
     @Override
-    public boolean blockActivated(World world, int x, int y, int z, EntityPlayer player)
+    public boolean onBlockRightClicked(World world, int x, int y, int z, EntityPlayer player, Side side, double xPlaced, double yPlaced)
     {
         if(player.getHeldItem() == null) {
             if (world.getBlockMetadata(x, y, z) == 0) {
